;
; PR.NO2ppb`
;

	relaxed on

BGMON		equ	$a72a
TIMERB		equ	$a72b
TIMERBCNT	equ	$a72c
BGMINT		equ	$a72d
HL_DIV_A	equ	$0b0a

DISKBUF		equ	$af00

DISPBACKSUB	equ	$c000
ERASE_20x20	equ	$c003
ERASE_20x4	equ	$c006
ERASE_4x20	equ	$c009
ERASE_8x8	equ	$c00c

; 0x0100`0x010d
; ݒ
;
	org	$0100
	ld	sp,$0000
	jr	$010e
;
; Wve[u
;
	org	$0105
	jp	CALCPOT		; 0x0105
	jp	CALCBACKADD	; 0x0108

; 0x010e`
; ̂܂܎gp
;
	org	$010e
	db	$ff

; 0x0e90`0x0f58
; fBXN[`igpȂ̂ŁAʂ̃[`j
;
	org	$0e90
	ld	a,$07
	ld	($0f5e),a
	ret


;
; XYWA20x20̂ǂ̈ʒuȂ̂ƁAzVRAMAhXZo
; HFYW
; LFXWi0`255j
;
; RETURN
; DEFzVRAMAhX
; HFYʒui0`4j
; LFXʒui0`4j
;
CALCPOT:
	ld	de,$6011	; zVRAM擪

	ld	a,l
	sub	8
	call	DIV20		; B <= 
	add	a,20		; A <= ]
	srl	a
	srl	a
	ld	l,a		; X
	ld	a,b
	add	a,e
	ld	e,a

	ld	a,h
	sub	10
	call	DIV20		; B <= 
	add	a,20		; A <= ]
	srl	a
	srl	a
	ld	h,a		; Y
	ld	a,b
	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8
	add	a,b		; x9
	add	a,e
	ld	e,a

	ret

;
; B <= A / 20
DIV20:
	ld	b,0
.lp1:	sub	20
	ret	c
	inc	b
	jr	.lp1

;
; wiLԍLf[^̊i[AhX߂
; AFLԍ
; RETURN
; HLFi[AhX
;
CALCBACKADD:
	push	bc

	ld	h,0
	ld	l,a
	ld	b,h
	ld	c,l
	add	hl,hl		; x2
	add	hl,bc		; x3
	add	hl,hl		; x6
	add	hl,hl		; x12
	add	hl,hl		; x24
	add	hl,bc		; x25
	add	hl,hl		; x50
	add	hl,hl		; x100
	ld	bc,$e000
	add	hl,bc

	pop	bc
	ret

;
; tHg̃AhXZo
; AFR[hi0x20`j
; RETURN
; DEFVRAMAhX
;
CALCFONTADD:
	ex	de,hl
	ld	h,0
	ld	l,a
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	ld	a,$f8+$01
	add	a,h
	ld	h,a
	ex	de,hl

	ret

;
; 88pVRAMAhXXYWɕϊ
; HLF88pVRAMAhX
; RETURN
; HFYW
; LFXW/2
;
VADDCONV:
	ld	a,h
	sub	$c0
	ld	h,a
	ld	a,80
	call	HL_DIV_A
	sla	l

	ret

;
; \ii L[͎j
;
DISPINV:
	ld	a,$0e		; wiɍ
	ld	(PUT1LETTER.colb+1),a

	call	$2579		; \

	ld	a,$07		; wi߂
	ld	(PUT1LETTER.colb+1),a

	call	$0fa4		; ʕ\

	jp	$3273

; 0x0f59`
; ̂܂܎gp
;
	org	$0f59
	db	$ff

; 0x0f6c`0x0f9b
; wip^[#0-2
;
	org	$0f6c

	db	$01,$01,$05,$ff,$10,$10,$50,$ff
	db	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	db	$fe,$fe,$fa,$00,$ef,$ef,$af,$00
	db	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	db	$aa,$d6,$6d,$92,$92,$6d,$d6,$aa
	db	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff


; 0x0f9c`
; ̂܂܎gp
;
	org	$0f9c
	db	$ff

; 0x0fdb`0x0fe9
; VRAMANZX{Fϊ
;
	org	$0fdb
ACCVRAM:
	push	af
	ld	a,$00
	out	($66),a		; 0xc000-0xdfffVRAMANZX
	out	($6e),a		; 0xc000-0xdfffVRAMANZX
	pop	af
	call	CONVCOLOR
	ret

; 0x0fea`0x0ff2
; CRAMɖ߂
;
	org	$0fea
ACCMRAM:
	push	af
	ld	a,$2c
	out	($66),a		; 0xc000-0xdfffORAMɖ߂
	out	($6e),a		; 0xc000-0xdfffORAMɖ߂
	pop	af
	ret

; 0x0ff3`0x1033
; ʃNAiFILLj
;
	org	$0ff3

SCRFILL:
	push	hl
	push	de
	push	bc
	push	af

	ld	bc,$a0c8	; XTCY/YTCY
	ld	d,0		; YW
	ld	hl,$c000	; XW
	call	DRAWBOX

	pop	af
	pop	bc
	pop	de
	pop	hl

	ret

;
; 88̐FSRpɕϊ
;
CONVCOLOR:
	push	hl
	push	bc

	ld	c,a
	ld	b,$00
	ld	hl,COLORTBL
	add	hl,bc
	ld	a,(hl)

	pop	bc
	pop	hl
	ret

COLORTBL:
	db	$0c		; GRB:000=>1100ipbgݒj
	db	$0d		; GRB:001=>1101ipbgݒj
	db	$0e		; GRB:010=>1110ipbgݒj
	db	$0e		; GRB:011=>1110ipbgݒj
	db	$0a		; GRB:100=>1010iԁj
	db	$0a		; GRB:101=>1010iԁj
	db	$0f		; GRB:110=>1111ipbgݒj
	db	$0f		; GRB:111=>1111ipbgݒj

; ``
; HLFXW
; DFYW
; BFhbgi2Ŋ́j
; CFchbg
;
DRAWBOX:
	call	ACCVRAM
	ld	e,a
	ld	a,d
	ld	d,b
	ld	(.pat+1),hl

.lp2:
	out	($ce),a
.pat:	ld	hl,$c000
	ld	b,d
.lp1:
	ld	(hl),e
	inc	hl
	ld	(hl),e
	inc	hl
	djnz	.lp1

	inc	a
	dec	c
	jr	nz,.lp2

	jr	ACCMRAM

; 0x1047`0x1058
; 
; HLFXW
; DFYW
; BCFhbg
;
	org	$1047
DRAWLINEH:
	call	ACCVRAM
	ld	e,a

	ld	a,d
	out	($ce),a
.lp1:
	ld	(hl),e
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,.lp1

	jp	ACCMRAM

; 0x1059`0x1066
; c
; HLFXW
; CFYW
; BFchbg
;
	org	$1059
DRAWLINEV:
	call	ACCVRAM
	ld	e,a
	ld	a,c
.lp1:
	out	($ce),a
	ld	(hl),e
	inc	a
	djnz	.lp1

	jp	ACCMRAM

; 0x1067`0x10b0
; }bvNA
;
	org	$1067
CLRMAPAREA:
	push	hl
	push	bc
	push	af

	call	ACCVRAM

	ld	c,180
.lp2:
	ld	a,180+10
	sub	c
	out	($ce),a

	xor	a

	ld	b,90
	ld	hl,$c000+8
.lp1:
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	djnz	.lp1

	dec	c
	jr	nz,.lp2

	call	ACCMRAM

	pop	af
	pop	bc
	pop	hl

	ret

; 0x10b1`0x10d9
; Xe[^X`悷
;
	org	$10b1
DRAWSTRAREA:
	push	hl
	push	bc
	push	af

	call	ACCVRAM

	ld	c,192
.lp2:
	ld	a,192+4
	sub	c
	out	($ce),a

	ld	a,$07		; `F

	ld	b,120
	ld	hl,$c000+196
.lp1:
	ld	(hl),a
	inc	hl
	djnz	.lp1

	dec	c
	jr	nz,.lp2

	call	ACCMRAM

	pop	af
	pop	bc
	pop	hl

	ret


; 0x10da`0x10e7
; Xe[^Xʂ̈ꕔNA
;
	org	$10da
	push	hl
	push	de
	push	bc
	push	af
	ld	d,145
	ld	e,4
	jr	CLRSTRAREA.jp

; 0x10e8`0x10f5
; Xe[^Xʂ̈ꕔNA
;
	org	$10e8
	push	hl
	push	de
	push	bc
	push	af
	ld	d,93
	ld	e,56
	jr	CLRSTRAREA.jp

; 0x10f6`0x1141
; Xe[^Xʂ̈ꕔNA
;
	org	$10f6

CLRSTRAREA:
	push	hl
	push	de
	push	bc
	push	af
	ld	d,125
	ld	e,24

.jp:
	call	ACCVRAM

.lp2:
	ld	a,e
	out	($ce),a

	ld	a,$07		; `F

	ld	b,120
	ld	hl,$c000+196
.lp1:
	ld	(hl),a
	inc	hl
	djnz	.lp1

	inc	e
	dec	d
	jr	nz,.lp2

	call	ACCMRAM

	pop	af
	pop	bc
	pop	de
	pop	hl

	ret

; 0x1142`0x11a9
; Xe[^X̓dg`
;
	org	$1142

DRAWSTRFRAME:
	push	hl
	push	de
	push	bc
	push	af

	ld	a,$04		; CF
	ld	d,150		; YW
	ld	bc,114		; hbg
	ld	hl,$c000+199	; XW
	push	hl
	push	bc
	call	DRAWLINEH
	pop	bc
	pop	hl
	ld	a,$04		; CF
	ld	d,193		; YW
	call	DRAWLINEH

	ld	a,$04		; CF
	ld	bc,$2c96	; chbg/YW
	ld	hl,$c000+199	; XW
	push	bc
	call	DRAWLINEV
	pop	bc
	ld	a,$04		; CF
	ld	hl,$c000+312	; XW
	call	DRAWLINEV

	ld	a,$02		; CF
	ld	d,149		; YW
	ld	bc,116		; hbg
	ld	hl,$c000+198	; XW
	push	hl
	push	bc
	call	DRAWLINEH
	pop	bc
	pop	hl
	ld	a,$02		; CF
	ld	d,194		; YW
	call	DRAWLINEH

	ld	a,$02		; CF
	ld	bc,$2e95	; chbg/YW
	ld	hl,$c000+198	; XW
	push	bc
	call	DRAWLINEV
	pop	bc
	ld	a,$02		; CF
	ld	hl,$c000+313	; XW
	call	DRAWLINEV

	jr	DRAWSTRTEXTBOX.jp

; 0x11aa`0x11c6
; Xe[^X̋``
;
	org	$11aa

DRAWSTRTEXTBOX:
	push	hl
	push	de
	push	bc
	push	af
.jp:

	ld	a,$02		; CF
	ld	bc,$382a	; XTCY/YTCY
	ld	d,151		; YW
	ld	hl,$c000+200	; XW
	call	DRAWBOX
	ld	hl,0
	ld	($6002),hl
	pop	af
	pop	bc
	pop	de
	pop	hl

	ret

; 0x11c7`0x1248
; 20x20wiL`
; AFLԍ
; HFYW
; LFXWi0`255܂Łj
;
;
	org	$11c7

DISPBACK:

	call	ACCBSUB
	call	DISPBACKSUB
	call	ACCMAIN

	exx
	ld	hl,$6178
	dec	(hl)
	exx

	ret

;
; 0xC000`0xDFFFRAMɂiwi`Tuj
;
ACCBSUB:
	push	af
	ld	a,$0c
	out	($66),a
	out	($6e),a
	pop	af
	ret

;
; 0xC000`0xDFFFORAMɂiCj
;
ACCMAIN:
	push	af
	ld	a,$2c
	out	($66),a
	out	($6e),a
	pop	af
	ret


; 0x1249`0x128f
; 20x20L\
; AFLԍ
; HLFVRAMAhX
;
	org	$1249
DISPCHR:
	push	hl
	push	de
	push	bc
	push	af

	ld	b,a

	ld	a,h
	or	l
	jr	z,.end		; HL=0x0000ȂWv

	ld	a,l
	and	h
	inc	a
	jr	z,.end		; HL=0xFFFFȂWv

	call	VADDCONV	; XYW߂
	sla	l

	ld	a,b
	or	a
	jr	nz,.next

	call	ACCBSUB
	call	ERASE_20x20	; 20x20wiL`
	call	ACCMAIN

	jr	.drawend

.next:

	push	hl
	call	CALCCHRADD	; 20x20LAhXZo
	pop	de

	call	DISPCHRSUB

.drawend:
	ld	hl,$6178
	dec	(hl)
	dec	(hl)
.end:
	pop	af
	pop	bc
	pop	de
	pop	hl
	ret


; 0x1290`0x1310
; _[Wpꕔ]
; HLFVRAMAhX
;
	org	$1290
DISPDMG:
	ld	a,h
	cp	$c0
	ret	c		; ͈͊OȂ烊^[

	push	ix
	push	hl
	push	de
	push	bc

	call	VADDCONV	; XYW߂
	sla	l

	call	ACCVRAM

	exx
	ld	d,DMGINVTABLE / $0100
	exx

	ld	ix,$ee10	; _[Wpp^[AhX
	ld	de,20-4		; AhX

	ld	a,l
	ld	(.xadd+1),a	; XW

	ld	b,20
.lp1:
	ld	a,h		; YW
	out	($ce),a

	exx

.xadd:	ld	hl,$c000

	ld	b,5

.lp2:
	ld	a,5
	sub	b
	add	a,a
	add	a,a
	ld	(.ptr+2),a
.ptr:	ld	c,(ix+00)
	rlc	c
	rlc	c
	rlc	c

	rlc	c
	jr	nc,.noiv1
	ld	e,(hl)
	ld	a,(de)
	ld	(hl),a
.noiv1:
	inc	l

	rlc	c
	jr	nc,.noiv2
	ld	e,(hl)
	ld	a,(de)
	ld	(hl),a
.noiv2:
	inc	l

	rlc	c
	jr	nc,.noiv3
	ld	e,(hl)
	ld	a,(de)
	ld	(hl),a
.noiv3:
	inc	l

	rlc	c
	jr	nc,.noiv4
	ld	e,(hl)
	ld	a,(de)
	ld	(hl),a
.noiv4:
	inc	l

	djnz	.lp2

	exx

	inc	ix
	ld	a,b
	dec	a
	and	$03
	jr	nz,.next

	add	ix,de

.next:
	inc	h
	djnz	.lp1


	call	ACCMRAM

	pop	bc
	pop	de
	pop	hl
	pop	ix
	ret

;
; w蕔iی^jGR̂ݔ]
;
; ϊe[u
; 1100:GBR=000  1111:GBR=110
; 1101:GBR=001  1111:GBR=110
; 1110:GBR=010  1010:GBR=100
; 1010:GBR=100  1110:GBR=010
; 1111:GBR=110  1100:GBR=000

	org	$1308
DMGINVTABLE:
	db	$08	;1000  1000igp̂͂j
	db	$09	;1001  1001igp̂͂j
	db	$0e	;1010  1110
	db	$0b	;1011  1011igp̂͂j
	db	$0f	;1100  1111
	db	$0f	;1101  1111
	db	$0a	;1110  1010
	db	$0c	;1111  1100


; 0x1311`0x131b
; 8x8L̔wi\
; iGRv[̃Lj
; HLFVRAMAhX
;
	org	$1311
PUT1BACK:
	push	hl
	push	de
	push	bc
	push	af
	jr	PUT1BACKSUB

; 0x131c`0x135b
; 8x8L\
; AFLԍi0x00`0x0Fj
; HLFVRAMAhX
;
	org	$131c
PUT1CHR:
	push	hl
	push	de
	push	bc
	push	af

	push	af

	call	VADDCONV	; XYW߂
	sla	l
	ex	de,hl

	pop	af

	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8
	ld	l,a
	ld	h,$f8/4
	add	hl,hl		; x16
	add	hl,hl		; x32

	ld	a,$ea				; ڃANZX[hɂ
	out	($c8),a

	call	PUT1CHRSUB

	ld	a,$e2				; rbg}bv[hɖ߂
	out	($c8),a

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

PUT1BACKSUB:
	call	VADDCONV	; XYW߂
	sla	l

	call	ACCBSUB
	call	ERASE_8x8	; 8x8wiL`
	call	ACCMAIN

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret


; 0x135c`0x13a5
; P\i8x8j
; AFR[hi0x20`j
; HLFVRAMAhX
; (0x6001)FF
;
	org	$135c
PUT1LETTER:
	push	hl
	push	de
	push	bc

	call	CALCFONTADD

	call	VADDCONV

	ld	c,h		; YW
	ld	h,$c0/2
	add	hl,hl		; XW
	ld	(.xadd+1),hl

	ld	l,$0e		; wiFiXe[^Xʁj
	ld	a,c
	cp	152
	jr	nc,.colb1
.colb:	ld	l,$07		; wiFiXe[^Xʁj
.colb1:
	ld	a,($6001)
	call	CONVCOLOR
	ld	h,a

	ld	(.col+1),hl

	xor	a
	out	($6e),a		; 0xC000-0xDFFFVRAMANZX

	ld	b,8
.lp2:
	ld	a,c
	out	($ce),a		; YW
	inc	c

	ld	a,(de)
	inc	de

	exx
.col:	ld	de,$0000
.xadd:	ld	hl,$c000	; XW
	ld	b,8

.lp1:

	ld	(hl),d		; F
	rlca
	jr	c,.n1
	ld	(hl),e		; wiF
.n1:	inc	hl

	djnz	.lp1

	exx

	djnz	.lp2

	call	ACCMRAM

	pop	bc
	pop	de
	pop	hl

	ret

; 0x13a6`
; ̂܂܎gp
;
	org	$13a6
	db	$ff

; 0x13b3`0x13b5
; }bv\iړpj
;
	org	$13b3
	ld	hl,$0a08	; =YX

; 0x13b6`
; ̂܂܎gp
;
	org	$13b6
	db	$ff

; 0x13e1`0x13e5
; }bv\iړpj
;
	org	$13e1
	ld	a,20
	add	a,l
	ld	l,a		; X=X+20
	nop

; 0x13e6`
; ̂܂܎gp
;
	org	$13e6
	db	$ff

; 0x13ee`0x13f0
; }bv\iړpj
;
	org	$13ee
	ld	bc,20*$100-180	; Y=Y+20 / X=X-180

; 0x13f1`
; ̂܂܎gp
;
	org	$13f1
	db	$ff

; 0x140b`0x140d
; }bv\
;
	org	$140b
	ld	hl,$0a08	; =YX

; 0x140e`
; ̂܂܎gp
;
	org	$140e
	db	$ff

; 0x1434`0x1438
; }bv\
;
	org	$1434
	ld	a,20
	add	a,l
	ld	l,a		; X=X+20
	nop

; 0x1439`
; ̂܂܎gp
;
	org	$1439
	db	$ff

; 0x1441`0x1443
; }bv\
;
	org	$1441
	ld	bc,20*$100-180	; Y=Y+20 / X=X-180

; 0x1444`
; ̂܂܎gp
;
	org	$1444
	db	$ff

; 0x145b`0x145d
; zVRAM̓e\
;
	org	$145b
	ld	hl,$0a08	; =YX

; 0x145e`
; ̂܂܎gp
;
	org	$145e
	db	$ff

; 0x1464`0x1468
; zVRAM̓e\
;
	org	$1464
	ld	a,20
	add	a,l
	ld	l,a		; X=X+20
	nop

; 0x1469`
; ̂܂܎gp
;
	org	$1469
	db	$ff

; 0x146b`0x146d
; zVRAM̓e\
;
	org	$146b
	ld	bc,20*$100-180	; Y=Y+20 / X=X-180

; 0x146e`
; ̂܂܎gp
;
	org	$146e
	db	$ff

; 0x1524`0x15b6
; ʘg`
;
	org	$1524
DRAWFRAME:
	ld	a,$02		; CF
	ld	d,0		; YW
	ld	bc,320		; hbg
	ld	hl,$c000	; XW
	push	hl
	push	bc
	call	DRAWLINEH
	pop	bc
	pop	hl
	ld	a,$02		; CF
	ld	d,199		; YW
	call	DRAWLINEH

	ld	a,$02		; CF
	ld	bc,$c800	; chbg/YW
	ld	hl,$c000	; XW
	push	bc
	call	DRAWLINEV
	pop	bc
	ld	a,$02		; CF
	ld	hl,$c000+319	; XW
	call	DRAWLINEV

	ld	a,$02		; CF
	ld	d,9		; YW
	ld	bc,182		; hbg
	ld	hl,$c000+7	; XW
	push	hl
	push	bc
	call	DRAWLINEH
	pop	bc
	pop	hl
	ld	a,$02		; CF
	ld	d,190		; XW
	call	DRAWLINEH

	ld	a,$02		; CF
	ld	bc,$b609	; chbg/YW
	ld	hl,$c000+7	; XW
	push	bc
	call	DRAWLINEV
	pop	bc
	ld	a,$02		; CF
	ld	hl,$c000+188	; XW
	call	DRAWLINEV

	ld	a,$02		; CF
	ld	d,3		; YW
	ld	bc,122		; hbg
	ld	hl,$c000+195	; XW
	push	hl
	push	bc
	call	DRAWLINEH
	pop	bc
	pop	hl
	ld	a,$02		; CF
	ld	d,196		; XW
	call	DRAWLINEH

	ld	a,$02		; CF
	ld	bc,$c203	; chbg/YW
	ld	hl,$c000+195	; XW
	push	bc
	call	DRAWLINEV
	pop	bc
	ld	a,$02		; CF
	ld	hl,$c000+316	; XW
	call	DRAWLINEV

	jr	$15b7

; 0x15b7`
; ̂܂܎gp
;
	org	$15b7
	db	$ff

; 0x15c1`0x15f3
; wp^[Ŗ߂
;
	org	$15c1
FILLPAT:
	call	ACCVRAM
	ld	(FILLPATSUB.pat+1),a

	ld	c,8
.lp5:
	ld	d,(ix+0)
	rrc	d
	inc	ix

.lp6:
	call	FILLPATSUB

	dec	c
	jr	nz,.lp5

	call	ACCMRAM
	ret


; 0x15f4`
; ̂܂܎gp
;
	org	$15f4
	db	$ff

; 0x1682`0x1683
; Xe[^XEʂ̕F
;
	org	$1682
	ld	a,$06

; 0x1684`
; ̂܂܎gp
;
	org	$1684
	db	$ff

; 0x1750`0x178a
; Xe[^XEʂ̃XN[
;
; (200,152)-(+14*8,+5*8)
;
	org	$1750
ST_SCROLL:
	push	af
	exx

	xor	a
	out	($66),a		; 0xC000-0xDFFFAVRAMǂݏo
	ld	a,$08
	out	($6e),a		; 0xC000-0xDFFFA0x8000-0x9FFFɑ΂ď

	call	SCROLL_SUB

	xor	a
	out	($6e),a		; 0xC000-0xDFFFAVRAMɏ
	ld	a,$08
	out	($66),a		; 0xC000-0xDFFFA0x8000-0x9FFFǂݏo

	ld	c,4
	ld	hl,$c000+14*8*2

.lp4:
	push	hl

	ld	a,152
	ld	b,5*8
.lp3:
	out	($ce),a
	inc	a
	push	bc

	ld	de,$c000+200
	ld	bc,14*8
	ldir

	pop	bc
	djnz	.lp3

	pop	hl
	ld	de,14*8*2
	add	hl,de

	dec	c
	jr	nz,.lp4


	call	ACCMRAM
	exx
	pop	af
	ret

; 0x178b`0x180e
; pbgݒ
;
	org	$178b

SETPALET:
	push	af
	push	bc
	push	hl

	ld	c,$02
	cp	$05

;	jr	nc,.poff

	jr	c,.next
	xor	a
.next:

	add	a,a		; x2
	add	a,a		; x4
	ld	c,a
	ld	b,$00
	ld	hl,PALETTBL
	add	hl,bc

	ld	bc,$0440
.lp1:
	ld	a,(hl)
	out	(c),a
	inc	hl
	inc	c
	djnz	.lp1

	ld	c,$03
.poff:
	ld	a,c
	out	($93),a

	pop	hl
	pop	bc
	pop	af
	ret


PALETTBL:

; pbgZbg#0
	db	$00	; 1111:=1111
	db	$07	; 1110:=1000
;	db	$0d	; 1101:=0010
	db	$01	; 1101:=1110
	db	$06	; 1100:=1001

; pbgZbg#1
	db	$00	; 1111:=1111
	db	$07	; 1110:=1000
	db	$03	; 1101:=1100
	db	$00	; 1100:=1111

; pbgZbg#2
	db	$00	; 1111:=1111
	db	$06	; 1110:=1001
	db	$07	; 1101:=1000
	db	$07	; 1100:=1000

; pbgZbg#3
	db	$00	; 1111:=1111
	db	$06	; 1110:=1001
	db	$05	; 1101:=1010
	db	$05	; 1100:=1010

; pbgZbg#4
	db	$00	; 1111:=1111
	db	$07	; 1110:=1000
	db	$07	; 1101:=1000
	db	$07	; 1100:=1000

;
; wp^[Ŗ߂iTu[`j
;
FILLPATSUB:

	ld	b,25
.lp4:
	ld	a,25
	sub	b
	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8
	add	a,8
	sub	c
	out	($ce),a

	push	bc

	ld	c,40
	ld	hl,$c000
	ld	a,d
.pat:	ld	e,$00
.lp3:

	ld	b,8
.lp2:	rlca
	jr	nc,.lp1
	ld	(hl),e
.lp1:	inc	hl
	djnz	.lp2

	dec	c
	jr	nz,.lp3

	pop	bc
	djnz	.lp4

	ret

;
; Xe[^XEʂ̃XN[iTu[`j
;
SCROLL_SUB:

	ld	de,$c000

	ld	a,152
	ld	b,5*8

.lp1:
	out	($ce),a
	inc	a
	push	bc

	ld	hl,$c000+200
	ld	bc,14*8
	ldir

	pop	bc
	djnz	.lp1

	ld	bc,14*8*8
	ex	de,hl
.lp2:
	ld	(hl),$0e	; 
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,.lp2

	ret


; 0x180f`
; ̂܂܎gp
;
	org	$180f
	db	$ff

; 0x1cd1`
; ړ
;
	org	$1cd1
	call	VADDCONV	; XYW߂
	sla	l

; 0x1cd6`
; ̂܂܎gp
;
	org	$1cd6
	db	$ff

; 0x1cde`0x1d00
; 40x4iwi`悷j
;
	org	$1cde
ERASECHR:
	call	ACCBSUB
	call	ERASE_20x4
	call	ACCMAIN
	jr	.end

	org	$1cf0
	call	ACCBSUB
	call	ERASE_4x20
	call	ACCMAIN

	org	$1cf9
	nop
	nop
	nop
.end:
	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

; 0x1d01`0x1d25
; LAhX̎Zo
; AFLԍ
; RETURN
; HLFLf[^AhX
;
	org	$1d01

CALCCHRADD:
	ld	hl,$ac00	; Lԍ0xFF
	cp	$ff
	ret	z
	cp	$40
	jr	c,.nom

	add	a,$40		; Lԍ0x40ȏ̎A0x8000 + 0x0100 x n
	ld	h,a
	ld	l,$00
	ret
.nom:
	ld	l,a		; Lԍ0x00`0x3fȏ̎A0xb000 + 0x00c8 x n
	ld	h,$00
	ld	e,l
	ld	d,h
	add	a,a		; x2
	add	a,l		; x3
	ld	l,a
	add	hl,hl		; x6
	add	hl,hl		; x12
	add	hl,hl		; x24
	add	hl,de		; x25
	add	hl,hl		; x50
	add	hl,hl		; x100
	add	hl,hl		; x200
	ld	de,$b000
	add	hl,de

	ret

; 0x1d26`
; ̂܂܎gp
;
	org	$1d26
	db	$ff

; 0x1df0`0x1df0
; ʒ̃L[ύXiCTRL-Bj
;
	org	$1df0
	db	$02

; 0x1df1`
; ̂܂܎gp
;
	org	$1df1
	db	$ff

; 0x1dfd`0x1dfe
; ̕\̔ѐ
;
	org	$1dfd
	dw	DISPINV

; 0x1dff`
; ̂܂܎gp
;
	org	$1dff
	db	$ff

; 0x2594`0x2594
; ̕\[`̕ύXii L[͎j
;
	org	$2594
	ret

; 0x2595`
; ̂܂܎gp
;
	org	$2595
	db	$ff

; 0x43ed`0x43f2
; BGMJn
;
	org	$43ed
	ld	a,$ff
	ld	(BGMON),a
	nop

; 0x43f3`
; ̂܂܎gp
;
	org	$43f3
	db	$ff

; 0x43f6`0x43fb
; BGM~
;
	org	$43f6
	ld	a,$00
	ld	(BGMON),a
	nop

; 0x43fc`
; ̂܂܎gp
;
	org	$43fc
	db	$ff

; 0x4442`0x4453
; OPN
;
	org	$4442
	xor	a
	ld	(BGMON),a
	jr	$4454

; 0x4454`
; ̂܂܎gp
;
	org	$4454
	db	$ff

; 0x4501`0x4502
; OPNóiDI/EIj
;
	org	$4501
	out	($a0),a

; 0x4503`
; ̂܂܎gp
;
	org	$4503
	db	$ff

; 0x4507`0x4508
; OPNóiDI/EIj
;
	org	$4507
	out	($a1),a

; 0x4509`
; ̂܂܎gp
;
	org	$4509
	db	$ff

; 0x4511`0x4512
; OPNóiDI/EIȂj
;
	org	$4511
	out	($a0),a

; 0x4513`
; ̂܂܎gp
;
	org	$4513
	db	$ff

; 0x4517`0x4518
; OPNóiDI/EIȂj
;
	org	$4517
	out	($a1),a

; 0x4519`
; ̂܂܎gp
;
	org	$4519
	db	$ff

; 0x4520`0x4521
; ^C}aX^[g
;
	org	$4520
	ld	e,$100-$e7

; 0x4522`
; ̂܂܎gp
;
	org	$4522
	db	$ff

; 0x452e`0x4549
; ^C}aX^[g
;
	org	$452e

TBSTART:
	ld	e,$100-$d6

	ld	a,(TIMERBCNT)	; -7 ꂽ̃^C}JE^ij
	cp	$100-$07
	jr	nc,.lp1
	xor	a
.lp1:
	add	a,e		; ^C}al
	ld	(TIMERBCNT),a

	ld	hl,$4351	; BGM荞ݔѐ
	ld	(BGMINT),hl
	ld	a,$ff		; BGMONɂ
	ld	(BGMON),a

	pop	af
	pop	de
	ret

; 0x454a`
; ̂܂܎gp
;
	org	$454a
	db	$ff

; 0x454b`0x454c
; OPN WAIT҂
;
	org	$454b
	in	a,($a3)

; 0x454b`
; ̂܂܎gp
;
	org	$454d
	db	$ff

;
; `pf[^
;
; Lf[^Ff0[1:0] / f1[1:0]
; wif[^@Fb0 / b1
;
;  f0[1] b0 b1 f0[0] f1[1] f1[0]
;
; e[ue
; ʂSrbgf1/b1
; ʂSrbgf0/b0
;
	org	$5c00
FBCHRTABLE:

	db	$cc,$ec,$ac,$fc,$ce,$ee,$ae,$fe		; 000000 - 000111
	db	$dc,$ec,$ac,$fc,$de,$ee,$ae,$fe		; 001000 - 001111
	db	$cd,$ed,$ad,$fd,$ce,$ee,$ae,$fe		; 010000 - 010111
	db	$dd,$ed,$ad,$fd,$de,$ee,$ae,$fe		; 011000 - 011111
	db	$ca,$ea,$aa,$fa,$cf,$ef,$af,$ff		; 100000 - 100111
	db	$da,$ea,$aa,$fa,$df,$ef,$af,$ff		; 101000 - 101111
	db	$ca,$ea,$aa,$fa,$cf,$ef,$af,$ff		; 110000 - 110111
	db	$da,$ea,$aa,$fa,$df,$ef,$af,$ff		; 111000 - 111111


; 8x8L\Tu
; HLFp^[AhX
; DFYW
; EFXWi0`255j

PUT1CHRSUB:
	push	hl
	ld	a,8*2
	ld	(DISPCHRSUB.yct+1),a		; VRAMɏރoCgi4~c4ɂQj
	ld	hl,12
	ld	(DISPCHRSUB.ptinc+1),hl		; p^[ItZbg
	ld	hl,$0106			; LD  B,1
	ld	(DISPCHRSUB.ysz2),hl		; cTCY
	ld	hl,$0000			; NOP / NOP
	ld	(DISPCHRSUB.xsz),hl		; TCY
	ld	a,3
	ld	(DISPCHRSUB.ylm+1),a		; Lׂp
	ld	a,2
	ld	(DISPCHRSUB.ysz1+1),a		; cTCY
	pop	hl

	call	DISPCHRSUB

	ld	a,8*5
	ld	(DISPCHRSUB.yct+1),a		; VRAMɏރoCgi4~c4ɂTj
	ld	hl,0
	ld	(DISPCHRSUB.ptinc+1),hl		; p^[ItZbg
	ld	(DISPCHRSUB.ysz2),hl		; cTCYiNOP/NOPj
	ld	hl,$0718			; jr .next
	ld	(DISPCHRSUB.xsz),hl		; TCY
	xor	a
	ld	(DISPCHRSUB.ylm+1),a		; Lׂp
	ld	a,5
	ld	(DISPCHRSUB.ysz1+1),a		; cTCY

	ret


; 20x20/8x8L\Tu
; HLFp^[AhX
; DFYW
; EFXWi0`255j

DISPCHRSUB:

	ld	a,$ea				; ڃANZX[hɂ
	out	($c8),a

	ld	(DISPFBMpNx4.fpt+1),hl		; LN^p^[AhX

.yct:	ld	a,8*5
	ld	(DISPFBMpNx4.yct+1),a		; VRAMɏރoCgi4~c4ɂQj
.ptinc:	ld	hl,0
	ld	(DISPFBMpNx4.ptinc+1),hl	; p^[ItZbg

	ld	a,d
	srl	a
	add	a,$1a
	ld	(DISPFBMpNx4.ypt+1),a		; JnYW

	ld	a,e
	ld	(DISPFBMpNx4.xpt+1),a		; JnXW

	ex	de,hl
	call	CALCPOT

	ld	b,h				; Y
	ld	c,l				; X

	push	bc				; YAX

	ld	a,(de)
	call	CALCBACKADD			; wip^[AhXij߂
	push	hl				; wip^[AhXij

	ld	a,b
	add	a,a				; Yx2
	add	a,a				; Yx4
	add	a,b				; Yx5
	add	a,c				; Yx5+X
	add	a,a				; Yx10+Xx2
	add	a,a				; Yx20+Xx4
	add	a,l
	ld	l,a
	jr	nc,.cinc1
	inc	h
.cinc1:	ld	(DISPFBMpNx4.bpt+1),hl		; wip^[AhXij

	ld	a,c
.xsz:	jr	.next

	cp	4
	ld	a,1
	jr	z,.next
	xor	a

.next:	add	a,a				; Xx2
	add	a,a				; Xx4
	add	a,a				; Xx8
	ld	(DISPFBMpNx4.lct1+1),a		; EL擪

	inc	de
	ld	a,(de)
	call	CALCBACKADD			; wip^[AhXiEj߂

	pop	bc				; wip^[AhXij
	or	a
	sbc	hl,bc
	ld	bc,-20
	add	hl,bc				; Ps镪̕␳

	ld	(DISPFBMpNx4.d12+1),hl		; Lp^[AhXiE|j
	ld	b,h
	ld	c,l
	ld	hl,0
	or	a
	sbc	hl,bc
	ld	(DISPFBMpNx4.d21+1),hl		; Lp^[AhXi|Ej

	pop	bc				; YAX

.ylm:	ld	a,0				; 0 / 3
	cp	b
	jr	c,.mx

			; cLN^ׂȂꍇ
.ysz1:	ld	a,5				; 5 / 2
	call	DISPFBMpNx4
	jr	.end

.mx:
	ld	a,5
	sub	b

	push	de
	push	bc
	call	DISPFBMpNx4
	pop	bc
	pop	de

	ld	hl,8
	add	hl,de
	ex	de,hl
	ld	a,(de)
	call	CALCBACKADD			; wip^[AhXij߂
	push	hl				; wip^[AhXij

	ld	a,c				; X
	add	a,a				; Xx2
	add	a,a				; Xx4
	add	a,l
	ld	l,a
	jr	nc,.cinc2
	inc	h
.cinc2:	ld	(DISPFBMpNx4.bpt+1),hl		; wip^[AhXij

	inc	de
	ld	a,(de)
	call	CALCBACKADD			; wip^[AhXiEj߂

	pop	de				; wip^[AhXij
	or	a
	sbc	hl,de
	ld	de,-20
	add	hl,de				; Ps镪̕␳

	ld	(DISPFBMpNx4.d12+1),hl		; Lp^[AhXiE|j
	ex	de,hl
	ld	hl,0
	or	a
	sbc	hl,de
	ld	(DISPFBMpNx4.d21+1),hl		; Lp^[AhXi|Ej

.ysz2:	nop					; nop,nop / ld b,1
	nop
	ld	a,b
	call	DISPFBMpNx4

.end:
	ld	a,$e2				; rbg}bv[hɖ߂
	out	($c8),a

	ret

;
; LN^{wi`TuiM+NhbgAcShbgj
;
DISPFBMpNx4:

	ld	h,FBCHRTABLE/$0100

.ypt:	ld	d,$00

	exx
.bpt:	ld	hl,$0000	; wip^[AhX
	ld	de,$1806	; wi#0/#1p}XN
	exx

.lp1:
	ex	af,af'
.xpt:	ld	e,$00

.yct:	ld	c,8*5		; VRAMɏރoCg

.lp2:
	di
	ld	(.spbuf+1),sp
.fpt:	ld	sp,$0000

		; 0x0000-0x7fffVRAMANZX
	xor	a
	out	($68),a
	ld	a,$02
	out	($69),a
	ld	a,$04
	out	($6a),a
	ld	a,$06
	out	($6b),a

	exx
	pop	bc		; SPFLN^p^[
	ld	a,(hl)		; HLFwip^[
	and	d		; DF0x18iwi#0j
	or	c
	exx

	ld	b,e
	ld	l,a
	ldi			; (0,0),(1,0)

	exx
	ld	a,(hl)
	and	e		; EF0x06iwi#1j
	rlca
	rlca
	or	b
	inc	hl
	exx

	ld	l,a
	ldi			; (2,0),(3,0)

	exx
	pop	bc
	ld	a,(hl)
	and	d
	or	c
	exx

	ld	l,a
	ldi			; (0,1),(1,1)

	exx
	ld	a,(hl)
	and	e
	rlca
	rlca
	or	b
	inc	hl
	exx

	ld	l,a
	ldi			; (2,1),(3,1)
	inc	d
	ld	e,b

	exx
	pop	bc
	ld	a,(hl)
	and	d
	or	c
	exx

	ld	l,a
	ldi			; (0,2),(1,2)

	exx
	ld	a,(hl)
	and	e
	rlca
	rlca
	or	b
	inc	hl
	exx

	ld	l,a
	ldi			; (2,2),(3,2)

	exx
	pop	bc
	ld	a,(hl)
	and	d
	or	c
	exx

	ld	l,a
	ldi			; (0,3),(1,3)

	exx
	ld	a,(hl)
	and	e
	rlca
	rlca
	or	b
	inc	hl
	exx

	ld	l,a
	ldi			; (2,3),(3,3)

		; 0x0000-0x7fffORAMɖ߂
	ld	a,$20
	out	($68),a
	ld	a,$22
	out	($69),a
	ld	a,$24
	out	($6a),a
	ld	a,$26
	out	($6b),a

	ld	(.fpt+1),sp
.spbuf:	ld	sp,$0000
	ei

	dec	d
	ld	a,c
.lct1:	cp	$00
	jr	z,.lct1p
	or	a
	jp	nz,.lp2

	exx
.d21:	ld	bc,$0000
	add	hl,bc
	exx

.lct2p:
	exx
.ptinc:	ld	bc,$0000		; p^[ItZbg
	add	hl,bc
	exx

	inc	d
	inc	d
	ex	af,af'
	dec	a
	jp	nz,.lp1

	ld	a,d
	ld	(.ypt+1),a

	ret

.lct1p:
	or	a
	jr	z,.lct2p

	exx
.d12:	ld	bc,$0000
	add	hl,bc
	exx

	jp	.lp2


; 0x5dff
; vȌI
;
	org	$5dff
	db	$ff


end
