/**************************************/
/* 88̃^Cg摜66SRpɕϊ */
/**************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXFLLEN	32
#define	MAXWIDTH	640
#define	MAXHEIGHT	200

void	fput2b(int,FILE *);
void	fput4b(int,FILE *);
void	outheader(int,int,FILE *);

void	convpic(int picsize_x,int picsize_y,int c_pixel[MAXWIDTH/2][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT]);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel[MAXWIDTH][MAXHEIGHT];
	int		c_pixel[MAXWIDTH/2][MAXHEIGHT];

	int		width,height;
	int		a0,a1,a2,a3;
	int		a4,a5,a6,a7;
	int		a8,a9,a10,a11,a12,a13,a14,a15;
	int		x,y;
	int		i,j;
	int		st;
	int		col,colsr;
	int		ysr;
	int		vram;
	int		staddx,staddy;
	int		outhigh,eqlen,deqlen,qeqlen,oeqlen;
	int		outdt4b;
	int		d0,d1;

	if (argc != 3) {
		fprintf(stderr, "Usage: convpict infile outfile\n");
		exit(1);
	}


/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	a0 = fgetc(infp);		/* JnAhX */
	a1 = fgetc(infp);		/* JnAhX */

	vram = a1*0x100 + a0 - 0xc000;
	staddy = (vram / 80);
	staddx = (vram - staddy * 80) * 4;

	a0 = fgetc(infp);			/* YTCY */
	a1 = fgetc(infp);			/* YTCY */

	height = (a1*0x100 + a0) / 3;

	width = fgetc(infp) * 8;	/* XTCY */
	fgetc(infp);				/* Jnv[igpj */

//	outheader(width, height*2, outfp);

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			pixel[x][y] = 0x08;
		}
	}

	col = 0x01;

	for (y = 0;y < height;) {
		a0 = fgetc(infp);

		if (a0 >= 0x80) {
			a0 -= 0x80;
			if (a0 >= 0x54) {
				colsr = 0x04;
				a0 -= 0x54;
			} else if (a0 >= 0x2a) {
				colsr = 0x02;
				a0 -= 0x2a;
			} else {
				colsr = 0x01;
			}

			ysr = fgetc(infp);

			for (x = 0;x < width;x ++) {
				if ( (pixel[x][ysr] & colsr) != 0) {
					pixel[x][y] |= col;
				} else {
					pixel[x][y] &= (col ^ 0xff);
				}
			}

			for (x = 0;x < a0*8;) {
				a1 = fgetc(infp);
				if (a1 >= 0xa0) {
					a1 -= 0xa0;
					a2 = 3;
				} else if (a1 >= 0x50) {
					a1 -= 0x50;
					a2 = 2;
				} else {
					a2 = 1;
				}

				for (i = 0;i < a2;i ++) {
					a3 = fgetc(infp);
					st = 0x80;
					for (j = 0;j < 8;j ++) {
						if ( (a3 & st) != 0) {
							pixel[a1*8+j][y] |= col;
						} else {
							pixel[a1*8+j][y] &= (col ^ 0xff);
						}
						st /= 2;
					}
					a1 ++;
					x += 8;
				}

			}

		} else {

			for (x = 0;x < width;) {

				if (x != 0) {
					a0 = fgetc(infp);
				}

				if (a0 >= 0x80) {
					a0 -= 0x80;
					for (i = 0;i < a0;i ++) {
						a1 = fgetc(infp);
						st = 0x80;
						for (j = 0;j < 8;j ++) {
							if ( (a1 & st) != 0) {
								pixel[x+j][y] |= col;
							} else {
								pixel[x+j][y] &= (col ^ 0xff);
							}
							st /= 2;
						}
						x += 8;
					}
				} else {
					a1 = fgetc(infp);
					for (i = 0;i < a0;i ++) {
						st = 0x80;
						for (j = 0;j < 8;j ++) {
							if ( (a1 & st) != 0) {
								pixel[x+j][y] |= col;
							} else {
								pixel[x+j][y] &= (col ^ 0xff);
							}
							st /= 2;
						}
						x += 8;
					}
				}

			}

		}

		if (col == 0x04) {
			col = 0x01;
			y ++;
		} else {
			col *= 2;
		} 

	}

/*
	for (y = height-1;y >= 0;y --) {
		for (i = 0;i < 2;i ++) {
			for (x = 0;x < width;x += 2) {
				a0 = (pixel[x][y] & 0x0f) << 4;
				a1 = (pixel[x+1][y] & 0x0f);
				fputc(a0|a1, outfp);
			}
		}
	}
*/

	convpic(width,height,c_pixel,pixel);

/*
	for (y = height-1;y >= 0;y --) {
		for (i = 0;i < 2;i ++) {
			for (x = 0;x < width/2;x ++) {
				a0 = (c_pixel[x][y] & 0x0f) << 4;
				a1 = (c_pixel[x][y] & 0x0f);
				fputc(a0|a1, outfp);
			}
		}
	}
*/

	fputc(  staddy,  outfp );
	fput2b( staddx,  outfp );
	fputc(  height,  outfp );
	fput2b( width/2, outfp );


/* f[^k */
/*
Ef[^́ASrbgP
E1st 0x8 ȏȂÂ܂܂̃f[^

E1st 0x0 Ȃ 1oCgk
E2nd 0x4`0xF ȂA3rd 2nd JԂ
E2nd 0x0 ȂA3rd  16 JԂ
E2nd 0x1 ȂA3rd  32 JԂ
E2nd 0x2 ȂA3rd  64 JԂ
E2nd 0x3 ȂA3rd  128 JԂ

E1st 0x1`0x7 Ȃ 2/4/8oCgk
E1st 0x2`0x7 ȂA2ndA3rd (,4th,5th,(6th,7th,8th,9th))1stJԂ
E1st 0x1 ȂA2ndA3rd (,4th,5th,(6th,7th,8th,9th))16JԂ
E2ndA0x8`0xfA3rdA0x8`0xfȂA2oCgkB
E2ndA0x0`0x7A3rdA0x8`0xfȂA4oCgkBJԂf[^́A2nd+8
E2ndA0x0`0x7A3rdA0x0`0x7ȂA8oCgkBJԂf[^́A2ndA3rd+8

EPŊBSrbgPʂŗ]ꍇ́AŌ 0x0 𖄂߂B
*/

	for (y = 0;y < height;y ++) {
		outhigh = 1;
		for (x = 0;x < width/2;) {

		// oCǧo
			eqlen = 0;
			a0 = c_pixel[x][y];
			for (i = x;i < width/2;i ++) {
				a1 = c_pixel[i][y];
				if (a0 != a1) {
					break;
				}
				eqlen ++;
			}

		// QoCgǍo
			deqlen = 0;
			if (x+1 < width/2) {
				a0 = c_pixel[x+0][y];
				a1 = c_pixel[x+1][y];
				for (i = x;i < width/2-1;i +=2) {
					a2 = c_pixel[i+0][y];
					a3 = c_pixel[i+1][y];
					if (a0 != a2 || a1 != a3) {
						break;
					}
					deqlen ++;
				}
			}

		// SoCgǍo
			qeqlen = 0;
			if (x+3 < width/2) {
				a0 = c_pixel[x+0][y];
				a1 = c_pixel[x+1][y];
				a2 = c_pixel[x+2][y];
				a3 = c_pixel[x+3][y];
				for (i = x;i < width/2-3;i +=4) {
					a4 = c_pixel[i+0][y];
					a5 = c_pixel[i+1][y];
					a6 = c_pixel[i+2][y];
					a7 = c_pixel[i+3][y];
					if (a0 != a4 || a1 != a5 || a2 != a6 || a3 != a7) {
						break;
					}
					qeqlen ++;
				}
			}

		// WoCgǍo
			oeqlen = 0;
			if (x+7 < width/2) {
				a0 = c_pixel[x+0][y];
				a1 = c_pixel[x+1][y];
				a2 = c_pixel[x+2][y];
				a3 = c_pixel[x+3][y];
				a4 = c_pixel[x+4][y];
				a5 = c_pixel[x+5][y];
				a6 = c_pixel[x+6][y];
				a7 = c_pixel[x+7][y];
				for (i = x;i < width/2-7;i +=8) {
					a8  = c_pixel[i+0][y];
					a9  = c_pixel[i+1][y];
					a10 = c_pixel[i+2][y];
					a11 = c_pixel[i+3][y];
					a12 = c_pixel[i+4][y];
					a13 = c_pixel[i+5][y];
					a14 = c_pixel[i+6][y];
					a15 = c_pixel[i+7][y];
					if (
						a0 !=  a8 || a1 !=  a9 || a2 != a10 || a3 != a11 ||
						a4 != a12 || a5 != a13 || a6 != a14 || a7 != a15
					) {
						break;
					}
					oeqlen ++;
				}
			}

			if (oeqlen >= 2 && eqlen < 8 && deqlen < 4 && qeqlen < 2) {		// WoCgk

				if (oeqlen >= 16) {
					outdt4b = 0x01;
					x += 16*8;
				} else if (oeqlen >= 7) {
					outdt4b = 0x07;
					x += 7*8;
				} else {
					outdt4b = oeqlen;
					x += qeqlen*8;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a0-8;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a1-8;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a2;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a3;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a4;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a5;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a6;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a7;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

			} else if (qeqlen >= 2 && eqlen < 4 && deqlen < 2) {		// SoCgk

				if (qeqlen >= 16) {
					outdt4b = 0x01;
					x += 16*4;
				} else if (qeqlen >= 7) {
					outdt4b = 0x07;
					x += 7*4;
				} else {
					outdt4b = qeqlen;
					x += qeqlen*4;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a0-8;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a1;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a2;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a3;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}


			} else if (deqlen >= 2 && eqlen < 4) {		// QoCgk

				if (deqlen >= 32) {
					outdt4b = 0x02;
					x += 32*2;
				} else if (deqlen >= 16) {
					outdt4b = 0x01;
					x += 16*2;
				} else if (deqlen >= 7) {
					outdt4b = 0x07;
					x += 7*2;
				} else {
					outdt4b = deqlen;
					x += deqlen*2;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a1;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}


			} else if (eqlen >= 4) {		// PoCgk

				outdt4b = 0x00;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				if (eqlen >= 128) {
					outdt4b = 0x03;
					x += 128;
				} else if (eqlen >= 64) {
					outdt4b = 0x02;
					x += 64;
				} else if (eqlen >= 32) {
					outdt4b = 0x01;
					x += 32;
				} else if (eqlen >= 16) {
					outdt4b = 0x00;
					x += 16;
				} else {
					outdt4b = eqlen;
					x += eqlen;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

			} else {					// kȂ

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}
				x ++;

			}

		}

		outdt4b = 0x00;
		if (outhigh != 1) {
			d1 = (outdt4b & 0x0f);
			fputc(d0|d1,outfp);
		}

	}

	fclose(outfp);
	fclose(infp);

	return(0);
}

void	fput2b(int d,FILE *fp)
{
	int	d0,d1;

	d0 = (d & 0x00ff);
	d1 = (d & 0xff00) >> 8;

	fputc(d0,fp);
	fputc(d1,fp);

	return;
}

void	fput4b(int d,FILE *fp)
{
	int	d0,d1,d2,d3;

	d0 = (d & 0x000000ff);
	d1 = (d & 0x0000ff00) >> 8;
	d2 = (d & 0x00ff0000) >> 16;
	d3 = (d & 0xff000f00) >> 24;

	fputc(d0,fp);
	fputc(d1,fp);
	fputc(d2,fp);
	fputc(d3,fp);

	return;
}

void	outheader(int w,int h,FILE *fp)
{
	int		fsize;

	fputc(0x42,fp);	// wb_[
	fputc(0x4d,fp);

	if ( (w & 0x01) != 0x00) {
		fsize = (w+1)*2*h + 0x76;
	} else {
		fsize = w*2*h + 0x76;
	}

	fput4b(fsize,fp);	// t@CTCY

	fput4b(0x00000000,fp);	// ɂO
	fput4b(0x00000076,fp);	// ɌŒl
	fput4b(0x00000028,fp);	// 40
	fput4b(w,fp);	// 
	fput4b(h,fp);	// 

	fputc(0x01,fp);	// ɂP
	fputc(0x00,fp);

	fputc(0x04,fp);	// ɂS
	fputc(0x00,fp);

	fput4b(0x00000000,fp);	// ɂO
	fput4b(0x00000000,fp);	// ɂO
	fput4b(0x00000000,fp);	// ɂO
	fput4b(0x00000000,fp);	// ɂO
	fput4b(0x00000010,fp);	// pbg
	fput4b(0x00000000,fp);	// ɂO

	// pbg

	fput4b(0x00000000,fp);
	fput4b(0x00ac00ff,fp);
	fput4b(0x00acff00,fp);
	fput4b(0x00ff00ac,fp);
	fput4b(0x0000ffac,fp);
	fput4b(0x0000acff,fp);
	fput4b(0x00acff00,fp);
	fput4b(0x00acacac,fp);
	fput4b(0x00000000,fp);
	fput4b(0x000000ff,fp);
	fput4b(0x00ff0000,fp);
	fput4b(0x00ff00ff,fp);
	fput4b(0x0000ff00,fp);
	fput4b(0x0000ffff,fp);
	fput4b(0x00ffff00,fp);
	fput4b(0x00ffffff,fp);

	return;
}



void	convpic(int picsize_x,int picsize_y,int c_pixel[MAXWIDTH/2][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT])
{
	int		x,y;

	int		c_pixel_tmp[MAXWIDTH/2][MAXHEIGHT];

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			c_pixel[x+0][y] = pixel[x*2+0][y];
		}

		for (x = 0;x < picsize_x/2 - 1;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+2][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+3][y])
			) {
				if ( (x%2) == 0) {
					c_pixel[x+0][y] = pixel[x*2+0][y];
					c_pixel[x+1][y] = pixel[x*2+3][y];
				} else {
					c_pixel[x+0][y] = pixel[x*2+1][y];
					c_pixel[x+1][y] = pixel[x*2+2][y];
				}
			}
		}

		for (x = 0;x < picsize_x/2 - 3;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+4][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+5][y]) &&
				(pixel[x*2+2][y] == pixel[x*2+6][y]) && 
				(pixel[x*2+3][y] == pixel[x*2+7][y])
			) {

				if (pixel[x*2+0][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}

				} else if (pixel[x*2+0][y] == pixel[x*2+1][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+2][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+3][y] == pixel[x*2+0][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				}
			}
		}
	}

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			c_pixel_tmp[x][y] = c_pixel[x][y];
		}
	}

	for (y = 1;y < picsize_y;y += 2) {
		for (x = 0;x < picsize_x/2 - 3;x ++) {

			if (
				(c_pixel_tmp[x+0][y-0] == c_pixel_tmp[x+2][y-0]) &&
				(c_pixel_tmp[x+1][y-0] == c_pixel_tmp[x+3][y-0]) &&
				(c_pixel_tmp[x+0][y-1] == c_pixel_tmp[x+2][y-1]) &&
				(c_pixel_tmp[x+1][y-1] == c_pixel_tmp[x+3][y-1]) &&
				( (c_pixel_tmp[x+0][y-0] == c_pixel_tmp[x+0][y-1]) ||
				  (c_pixel_tmp[x+1][y-0] == c_pixel_tmp[x+1][y-1]) 
				)
			) {
				c_pixel[x+0][y] = c_pixel_tmp[x+1][y];
				c_pixel[x+1][y] = c_pixel_tmp[x+0][y];
				c_pixel[x+2][y] = c_pixel_tmp[x+3][y];
				c_pixel[x+3][y] = c_pixel_tmp[x+2][y];
			}

		}
	}

	return;
}


